;Macro para representar uma sequencia de degraus laminados em nadeira 
;Macro realizada pela aluna Carla Costa, da turma B do 3 ano
;Modelacao e Visualizacao Tridimensional em Arquitetura lecionada pelo professor Luis Romao
;Mestrado Integrado em Arquitetura - Faculdade de Arquitetura - UL
;Ano Letivo 2021_2022

(defun c:degraus() 

    (setq pontoS (getvar "osmode"))
	(setq pontoS3d (getvar "3dosmode"))
	(setvar "3dosmode" 0)
	
;Obter ponto de partida

	(setvar "osmode" 1)
	(setq p1 (getpoint "\nIndique o ponto de arranque: "))
	
;Obter pontos para a personalizacao do degrau

	(setq largura (getreal "\nIndique o ponto da largura do degrau: "))
	(setq espelho (getreal "\nIndique o espelho: "))
	(setq cobertor (getreal "\nIndique o cobertor: "))

;Exemplo para personalizacao do degrau

	;(setq p1 (getpoint "\nIndique o ponto de arranque: <0.0> "))
	;))
	;(setq largura (getreal "\nIndique o ponto da largura do degrau: <2m> "))
	;))
	;(setq espelho (getreal "\nIndique o espelho: <0.035m> "))
	;))
	;(setq cobertor (getreal "\nIndique o cobertor: <0.334m> "))
	;))
	
;Obter a repeticao

	(setq ndegraus (getint "\n Indique o numero de degraus: " ))

	   
	   (command "ucs" p1 "" )
	   (setq p1 (trans p1 0 1))
	  (command "box" p1 (list largura cobertor espelho))
	  
;Pontos de coordenada normais

	  (command "ucs" "world")
	  
;Obter a modelacao das escadas

	  (repeat ndegraus  
	   (command "copy" "last" "" p1 (list 0 cobertor espelho))
	)
	)